Index: django/contrib/localflavor/fi/fi_municipalities.py
===================================================================
--- django/contrib/localflavor/fi/fi_municipalities.py	(revision 12863)
+++ django/contrib/localflavor/fi/fi_municipalities.py	(working copy)
@@ -9,22 +9,15 @@
 
 MUNICIPALITY_CHOICES = (
     ('akaa', u"Akaa"),
-    ('alaharma', u"Alahärmä"),
     ('alajarvi', u"Alajärvi"),
-    ('alastaro', u"Alastaro"),
     ('alavieska', u"Alavieska"),
     ('alavus', u"Alavus"),
-    ('anjalankoski', u"Anjalankoski"),
     ('artjarvi', u"Artjärvi"),
     ('asikkala', u"Asikkala"),
-    ('askainen', u"Askainen"),
     ('askola', u"Askola"),
     ('aura', u"Aura"),
     ('brando', u"Brändö"),
-    ('dragsfjard', u"Dragsfjärd"),
     ('eckero', u"Eckerö"),
-    ('elimaki', u"Elimäki"),
-    ('eno', u"Eno"),
     ('enonkoski', u"Enonkoski"),
     ('enontekio', u"Enontekiö"),
     ('espoo', u"Espoo"),
@@ -38,7 +31,6 @@
     ('haapajarvi', u"Haapajärvi"),
     ('haapavesi', u"Haapavesi"),
     ('hailuoto', u"Hailuoto"),
-    ('halikko', u"Halikko"),
     ('halsua', u"Halsua"),
     ('hamina', u"Hamina"),
     ('hammarland', u"Hammarland"),
@@ -47,17 +39,14 @@
     ('harjavalta', u"Harjavalta"),
     ('hartola', u"Hartola"),
     ('hattula', u"Hattula"),
-    ('hauho', u"Hauho"),
     ('haukipudas', u"Haukipudas"),
     ('hausjarvi', u"Hausjärvi"),
     ('heinola', u"Heinola"),
     ('heinavesi', u"Heinävesi"),
     ('helsinki', u"Helsinki"),
-    ('himanka', u"Himanka"),
     ('hirvensalmi', u"Hirvensalmi"),
     ('hollola', u"Hollola"),
     ('honkajoki', u"Honkajoki"),
-    ('houtskari', u"Houtskari"),
     ('huittinen', u"Huittinen"),
     ('humppila', u"Humppila"),
     ('hyrynsalmi', u"Hyrynsalmi"),
@@ -73,11 +62,9 @@
     ('ilomantsi', u"Ilomantsi"),
     ('imatra', u"Imatra"),
     ('inari', u"Inari"),
-    ('inio', u"Iniö"),
     ('inkoo', u"Inkoo"),
     ('isojoki', u"Isojoki"),
     ('isokyro', u"Isokyrö"),
-    ('jaala', u"Jaala"),
     ('jalasjarvi', u"Jalasjärvi"),
     ('janakkala', u"Janakkala"),
     ('joensuu', u"Joensuu"),
@@ -85,30 +72,24 @@
     ('jomala', u"Jomala"),
     ('joroinen', u"Joroinen"),
     ('joutsa', u"Joutsa"),
-    ('joutseno', u"Joutseno"),
     ('juankoski', u"Juankoski"),
-    ('jurva', u"Jurva"),
     ('juuka', u"Juuka"),
     ('juupajoki', u"Juupajoki"),
     ('juva', u"Juva"),
     ('jyvaskyla', u"Jyväskylä"),
-    ('jyvaskylan_mlk', u"Jyväskylän maalaiskunta"),
     ('jamijarvi', u"Jämijärvi"),
     ('jamsa', u"Jämsä"),
-    ('jamsankoski', u"Jämsänkoski"),
     ('jarvenpaa', u"Järvenpää"),
     ('kaarina', u"Kaarina"),
     ('kaavi', u"Kaavi"),
     ('kajaani', u"Kajaani"),
     ('kalajoki', u"Kalajoki"),
-    ('kalvola', u"Kalvola"),
     ('kangasala', u"Kangasala"),
     ('kangasniemi', u"Kangasniemi"),
     ('kankaanpaa', u"Kankaanpää"),
     ('kannonkoski', u"Kannonkoski"),
     ('kannus', u"Kannus"),
     ('karijoki', u"Karijoki"),
-    ('karjaa', u"Karjaa"),
     ('karjalohja', u"Karjalohja"),
     ('karkkila', u"Karkkila"),
     ('karstula', u"Karstula"),
@@ -123,23 +104,19 @@
     ('kemi', u"Kemi"),
     ('kemijarvi', u"Kemijärvi"),
     ('keminmaa', u"Keminmaa"),
-    ('kemio', u"Kemiö"),
+    ('kemionsaari', u"Kemiönsaari"),
     ('kempele', u"Kempele"),
     ('kerava', u"Kerava"),
     ('kerimaki', u"Kerimäki"),
-    ('kestila', u"Kestilä"),
     ('kesalahti', u"Kesälahti"),
     ('keuruu', u"Keuruu"),
     ('kihnio', u"Kihniö"),
-    ('kiikala', u"Kiikala"),
     ('kiikoinen', u"Kiikoinen"),
     ('kiiminki', u"Kiiminki"),
     ('kinnula', u"Kinnula"),
     ('kirkkonummi', u"Kirkkonummi"),
-    ('kisko', u"Kisko"),
     ('kitee', u"Kitee"),
     ('kittila', u"Kittilä"),
-    ('kiukainen', u"Kiukainen"),
     ('kiuruvesi', u"Kiuruvesi"),
     ('kivijarvi', u"Kivijärvi"),
     ('kokemaki', u"Kokemäki"),
@@ -147,11 +124,8 @@
     ('kolari', u"Kolari"),
     ('konnevesi', u"Konnevesi"),
     ('kontiolahti', u"Kontiolahti"),
-    ('korpilahti', u"Korpilahti"),
-    ('korppoo', u"Korppoo"),
     ('korsnas', u"Korsnäs"),
-    ('kortesjarvi', u"Kortesjärvi"),
-    ('koskitl', u"KoskiTl"),
+    ('koskitl', u"Koski Tl"),
     ('kotka', u"Kotka"),
     ('kouvola', u"Kouvola"),
     ('kristiinankaupunki', u"Kristiinankaupunki"),
@@ -163,14 +137,10 @@
     ('kuopio', u"Kuopio"),
     ('kuortane', u"Kuortane"),
     ('kurikka', u"Kurikka"),
-    ('kuru', u"Kuru"),
     ('kustavi', u"Kustavi"),
     ('kuusamo', u"Kuusamo"),
-    ('kuusankoski', u"Kuusankoski"),
-    ('kuusjoki', u"Kuusjoki"),
     ('kylmakoski', u"Kylmäkoski"),
     ('kyyjarvi', u"Kyyjärvi"),
-    ('kalvia', u"Kälviä"),
     ('karkola', u"Kärkölä"),
     ('karsamaki', u"Kärsämäki"),
     ('kokar', u"Kökar"),
@@ -178,30 +148,23 @@
     ('lahti', u"Lahti"),
     ('laihia', u"Laihia"),
     ('laitila', u"Laitila"),
-    ('lammi', u"Lammi"),
     ('lapinjarvi', u"Lapinjärvi"),
     ('lapinlahti', u"Lapinlahti"),
     ('lappajarvi', u"Lappajärvi"),
     ('lappeenranta', u"Lappeenranta"),
-    ('lappi', u"Lappi"),
     ('lapua', u"Lapua"),
     ('laukaa', u"Laukaa"),
     ('lavia', u"Lavia"),
-    ('lehtimaki', u"Lehtimäki"),
-    ('leivonmaki', u"Leivonmäki"),
     ('lemi', u"Lemi"),
     ('lemland', u"Lemland"),
     ('lempaala', u"Lempäälä"),
-    ('lemu', u"Lemu"),
     ('leppavirta', u"Leppävirta"),
     ('lestijarvi', u"Lestijärvi"),
     ('lieksa', u"Lieksa"),
     ('lieto', u"Lieto"),
-    ('liljendal', u"Liljendal"),
     ('liminka', u"Liminka"),
     ('liperi', u"Liperi"),
     ('lohja', u"Lohja"),
-    ('lohtaja', u"Lohtaja"),
     ('loimaa', u"Loimaa"),
     ('loppi', u"Loppi"),
     ('loviisa', u"Loviisa"),
@@ -211,42 +174,36 @@
     ('luoto', u"Luoto"),
     ('luumaki', u"Luumäki"),
     ('luvia', u"Luvia"),
+    ('lansi-turunmaa', u"Länsi-Turunmaa"),
     ('maalahti', u"Maalahti"),
     ('maaninka', u"Maaninka"),
     ('maarianhamina', u"Maarianhamina"),
     ('marttila', u"Marttila"),
     ('masku', u"Masku"),
-    ('mellila', u"Mellilä"),
     ('merijarvi', u"Merijärvi"),
     ('merikarvia', u"Merikarvia"),
-    ('merimasku', u"Merimasku"),
     ('miehikkala', u"Miehikkälä"),
     ('mikkeli', u"Mikkeli"),
-    ('mouhijarvi', u"Mouhijärvi"),
     ('muhos', u"Muhos"),
     ('multia', u"Multia"),
     ('muonio', u"Muonio"),
     ('mustasaari', u"Mustasaari"),
     ('muurame', u"Muurame"),
-    ('muurla', u"Muurla"),
     ('mynamaki', u"Mynämäki"),
     ('myrskyla', u"Myrskylä"),
     ('mantsala', u"Mäntsälä"),
-    ('mantta', u"Mänttä"),
+    ('mantta-vilppula', u"Mänttä-Vilppula"),
     ('mantyharju', u"Mäntyharju"),
     ('naantali', u"Naantali"),
     ('nakkila', u"Nakkila"),
     ('nastola', u"Nastola"),
-    ('nauvo', u"Nauvo"),
     ('nilsia', u"Nilsiä"),
     ('nivala', u"Nivala"),
     ('nokia', u"Nokia"),
-    ('noormarkku', u"Noormarkku"),
     ('nousiainen', u"Nousiainen"),
     ('nummi-pusula', u"Nummi-Pusula"),
     ('nurmes', u"Nurmes"),
     ('nurmijarvi', u"Nurmijärvi"),
-    ('nurmo', u"Nurmo"),
     ('narpio', u"Närpiö"),
     ('oravainen', u"Oravainen"),
     ('orimattila', u"Orimattila"),
@@ -259,26 +216,19 @@
     ('padasjoki', u"Padasjoki"),
     ('paimio', u"Paimio"),
     ('paltamo', u"Paltamo"),
-    ('parainen', u"Parainen"),
     ('parikkala', u"Parikkala"),
     ('parkano', u"Parkano"),
     ('pedersore', u"Pedersöre"),
     ('pelkosenniemi', u"Pelkosenniemi"),
     ('pello', u"Pello"),
     ('perho', u"Perho"),
-    ('pernaja', u"Pernaja"),
-    ('pernio', u"Perniö"),
-    ('pertteli', u"Pertteli"),
     ('pertunmaa', u"Pertunmaa"),
     ('petajavesi', u"Petäjävesi"),
     ('pieksamaki', u"Pieksämäki"),
     ('pielavesi', u"Pielavesi"),
     ('pietarsaari', u"Pietarsaari"),
     ('pihtipudas', u"Pihtipudas"),
-    ('piikkio', u"Piikkiö"),
-    ('piippola', u"Piippola"),
     ('pirkkala', u"Pirkkala"),
-    ('pohja', u"Pohja"),
     ('polvijarvi', u"Polvijärvi"),
     ('pomarkku', u"Pomarkku"),
     ('pori', u"Pori"),
@@ -287,7 +237,6 @@
     ('posio', u"Posio"),
     ('pudasjarvi', u"Pudasjärvi"),
     ('pukkila', u"Pukkila"),
-    ('pulkkila', u"Pulkkila"),
     ('punkaharju', u"Punkaharju"),
     ('punkalaidun', u"Punkalaidun"),
     ('puolanka', u"Puolanka"),
@@ -297,45 +246,40 @@
     ('pyhajarvi', u"Pyhäjärvi"),
     ('pyhanta', u"Pyhäntä"),
     ('pyharanta', u"Pyhäranta"),
-    ('pyhaselka', u"Pyhäselkä"),
-    ('pylkonmaki', u"Pylkönmäki"),
     ('palkane', u"Pälkäne"),
     ('poytya', u"Pöytyä"),
     ('raahe', u"Raahe"),
+    ('raasepori', u"Raasepori"),
     ('raisio', u"Raisio"),
     ('rantasalmi', u"Rantasalmi"),
-    ('rantsila', u"Rantsila"),
     ('ranua', u"Ranua"),
     ('rauma', u"Rauma"),
     ('rautalampi', u"Rautalampi"),
     ('rautavaara', u"Rautavaara"),
     ('rautjarvi', u"Rautjärvi"),
     ('reisjarvi', u"Reisjärvi"),
-    ('renko', u"Renko"),
     ('riihimaki', u"Riihimäki"),
     ('ristiina', u"Ristiina"),
     ('ristijarvi', u"Ristijärvi"),
     ('rovaniemi', u"Rovaniemi"),
     ('ruokolahti', u"Ruokolahti"),
-    ('ruotsinpyhtaa', u"Ruotsinpyhtää"),
     ('ruovesi', u"Ruovesi"),
     ('rusko', u"Rusko"),
-    ('rymattyla', u"Rymättylä"),
     ('raakkyla', u"Rääkkylä"),
     ('saarijarvi', u"Saarijärvi"),
     ('salla', u"Salla"),
     ('salo', u"Salo"),
     ('saltvik', u"Saltvik"),
-    ('sammatti', u"Sammatti"),
+    ('sastamala', u"Sastamala"),
     ('sauvo', u"Sauvo"),
     ('savitaipale', u"Savitaipale"),
     ('savonlinna', u"Savonlinna"),
-    ('savonranta', u"Savonranta"),
     ('savukoski', u"Savukoski"),
     ('seinajoki', u"Seinäjoki"),
     ('sievi', u"Sievi"),
     ('siikainen', u"Siikainen"),
     ('siikajoki', u"Siikajoki"),
+    ('siikalatva', u"Siikalatva"),
     ('siilinjarvi', u"Siilinjärvi"),
     ('simo', u"Simo"),
     ('sipoo', u"Sipoo"),
@@ -349,17 +293,14 @@
     ('sulkava', u"Sulkava"),
     ('sund', u"Sund"),
     ('suomenniemi', u"Suomenniemi"),
-    ('suomusjarvi', u"Suomusjärvi"),
     ('suomussalmi', u"Suomussalmi"),
     ('suonenjoki', u"Suonenjoki"),
     ('sysma', u"Sysmä"),
     ('sakyla', u"Säkylä"),
-    ('sarkisalo', u"Särkisalo"),
     ('taipalsaari', u"Taipalsaari"),
     ('taivalkoski', u"Taivalkoski"),
     ('taivassalo', u"Taivassalo"),
     ('tammela', u"Tammela"),
-    ('tammisaari', u"Tammisaari"),
     ('tampere', u"Tampere"),
     ('tarvasjoki', u"Tarvasjoki"),
     ('tervo', u"Tervo"),
@@ -370,12 +311,10 @@
     ('toivakka', u"Toivakka"),
     ('tornio', u"Tornio"),
     ('turku', u"Turku"),
-    ('tuulos', u"Tuulos"),
     ('tuusniemi', u"Tuusniemi"),
     ('tuusula', u"Tuusula"),
     ('tyrnava', u"Tyrnävä"),
     ('toysa', u"Töysä"),
-    ('ullava', u"Ullava"),
     ('ulvila', u"Ulvila"),
     ('urjala', u"Urjala"),
     ('utajarvi', u"Utajärvi"),
@@ -385,17 +324,12 @@
     ('uusikaupunki', u"Uusikaupunki"),
     ('vaala', u"Vaala"),
     ('vaasa', u"Vaasa"),
-    ('vahto', u"Vahto"),
     ('valkeakoski', u"Valkeakoski"),
-    ('valkeala', u"Valkeala"),
     ('valtimo', u"Valtimo"),
-    ('vammala', u"Vammala"),
-    ('vampula', u"Vampula"),
     ('vantaa', u"Vantaa"),
     ('varkaus', u"Varkaus"),
     ('varpaisjarvi', u"Varpaisjärvi"),
     ('vehmaa', u"Vehmaa"),
-    ('velkua', u"Velkua"),
     ('vesanto', u"Vesanto"),
     ('vesilahti', u"Vesilahti"),
     ('veteli', u"Veteli"),
@@ -403,25 +337,17 @@
     ('vihanti', u"Vihanti"),
     ('vihti', u"Vihti"),
     ('viitasaari', u"Viitasaari"),
-    ('vilppula', u"Vilppula"),
     ('vimpeli', u"Vimpeli"),
     ('virolahti', u"Virolahti"),
     ('virrat', u"Virrat"),
     ('vardo', u"Vårdö"),
     ('vahakyro', u"Vähäkyrö"),
-    ('vastanfjard', u"Västanfjärd"),
     ('voyri-maksamaa', u"Vöyri-Maksamaa"),
-    ('yliharma', u"Ylihärmä"),
     ('yli-ii', u"Yli-Ii"),
-    ('ylikiiminki', u"Ylikiiminki"),
-    ('ylistaro', u"Ylistaro"),
     ('ylitornio', u"Ylitornio"),
     ('ylivieska', u"Ylivieska"),
-    ('ylamaa', u"Ylämaa"),
-    ('ylane', u"Yläne"),
     ('ylojarvi', u"Ylöjärvi"),
     ('ypaja', u"Ypäjä"),
-    ('aetsa', u"Äetsä"),
     ('ahtari', u"Ähtäri"),
     ('aanekoski', u"Äänekoski")
 )
\ No newline at end of file