diff --git a/AUTHORS b/AUTHORS
index bf63b10..7741fa6 100644
--- a/AUTHORS
+++ b/AUTHORS
@@ -197,6 +197,7 @@ answer newbie questions, and generally made Django that much better:
     David Gouldin <dgouldin@gmail.com>
     pradeep.gowda@gmail.com
     Collin Grady <collin@collingrady.com>
+    Gabriel Grant <g@briel.ca>
     Simon Greenhill <dev@simon.net.nz>
     Owen Griffiths
     Espen Grindhaug <http://grindhaug.org/>
diff --git a/django/db/models/base.py b/django/db/models/base.py
index b3deda1..1fc3609 100644
--- a/django/db/models/base.py
+++ b/django/db/models/base.py
@@ -5,7 +5,8 @@ import django.db.models.manager     # Imported to register signal handler.
 from django.core.exceptions import ObjectDoesNotExist, MultipleObjectsReturned, FieldError, ValidationError, NON_FIELD_ERRORS
 from django.core import validators
 from django.db.models.fields import AutoField, FieldDoesNotExist
-from django.db.models.fields.related import OneToOneRel, ManyToOneRel, OneToOneField
+from django.db.models.fields.related import (OneToOneRel, ManyToOneRel,
+    OneToOneField, add_lazy_relation)
 from django.db.models.query import delete_objects, Q
 from django.db.models.query_utils import CollectedObjects, DeferredAttribute
 from django.db.models.options import Options
@@ -223,8 +224,25 @@ class ModelBase(type):
         if opts.order_with_respect_to:
             cls.get_next_in_order = curry(cls._get_next_or_previous_in_order, is_next=True)
             cls.get_previous_in_order = curry(cls._get_next_or_previous_in_order, is_next=False)
-            setattr(opts.order_with_respect_to.rel.to, 'get_%s_order' % cls.__name__.lower(), curry(method_get_order, cls))
-            setattr(opts.order_with_respect_to.rel.to, 'set_%s_order' % cls.__name__.lower(), curry(method_set_order, cls))
+            # defer creating accessors on the foreign class until we are
+            # certain it has been created
+            def make_foreign_order_accessors(field, model, cls):
+                setattr(
+                    field.rel.to,
+                    'get_%s_order' % cls.__name__.lower(),
+                    curry(method_get_order, cls)
+                )
+                setattr(
+                    field.rel.to,
+                    'set_%s_order' % cls.__name__.lower(),
+                    curry(method_set_order, cls)
+                )
+            add_lazy_relation(
+                cls,
+                opts.order_with_respect_to,
+                opts.order_with_respect_to.rel.to,
+                make_foreign_order_accessors
+            )
 
         # Give the class a docstring -- its definition.
         if cls.__doc__ is None:
diff --git a/tests/modeltests/order_with_respect_to/models.py b/tests/modeltests/order_with_respect_to/models.py
index 99c9f13..64a0a7c 100644
--- a/tests/modeltests/order_with_respect_to/models.py
+++ b/tests/modeltests/order_with_respect_to/models.py
@@ -17,6 +17,16 @@ class Answer(models.Model):
     def __unicode__(self):
         return unicode(self.text)
 
+class Post(models.Model):
+    title = models.CharField(max_length=200)
+    parent = models.ForeignKey("self", related_name="children", null=True)
+
+    class Meta:
+        order_with_respect_to = "parent"
+
+    def __unicode__(self):
+        return self.title
+
 __test__ = {'API_TESTS': """
 >>> q1 = Question(text="Which Beatle starts with the letter 'R'?")
 >>> q1.save()
diff --git a/tests/modeltests/order_with_respect_to/tests.py b/tests/modeltests/order_with_respect_to/tests.py
new file mode 100644
index 0000000..069aab1
--- /dev/null
+++ b/tests/modeltests/order_with_respect_to/tests.py
@@ -0,0 +1,14 @@
+from django.test import TestCase
+
+from models import Post
+
+
+class RecursiveTests(TestCase):
+    def test_recursive_ordering(self):
+        p1 = Post.objects.create(title='1')
+        p2 = Post.objects.create(title='2')
+        p1_1 = Post.objects.create(title="1.1", parent=p1)
+        p1_2 = Post.objects.create(title="1.2", parent=p1)
+        p2_1 = Post.objects.create(title="2.1", parent=p2)
+        p1_3 = Post.objects.create(title="1.3", parent=p1)
+        self.assertEqual(p1.get_post_order(), [3, 4, 6])